var phidget22 = require('phidget22');

var SERVER_PORT = 5661;

function main() {

	if (process.argv.length != 3) {
		console.log('usage: node RFID.js <server address>');
		process.exit(1);
	}
	var hostname = process.argv[2];

	console.log('connecting to:' + hostname);
	var conn = new phidget22.Connection(SERVER_PORT, hostname, { name: 'Server Connection', passwd: '' });
	conn.connect()
		.then(runExample)
		.catch(function (err) {
			console.error('Error running example:', err.message);
			process.exit(1);
		});
}

function runExample() {

	console.log('connected to server');
	var ch = new phidget22.RFID();

	ch.onAttach = function (ch) {
		console.log(ch + ' attached');
	};

	ch.onDetach = function (ch) {
		console.log(ch + ' detached');
	};

	ch.onTag = function (tag, protocol) {
		var protocolStr;
		switch (protocol) {
			case phidget22.RFIDProtocol.EM4100:
				protocolStr = 'EM4100';
				break;
			case phidget22.RFIDProtocol.ISO11785_FDX_B:
				protocolStr = 'ISO11785_FDX_B';
				break;
			case phidget22.RFIDProtocol.PHIDGET_TAG:
				protocolStr = 'PHIDGET_TAG';
				break;
		}

		console.log('Tag: ' + tag + "\tProtocol: " + protocolStr)
	}

	ch.onTagLost = function (tag, protocol) {
		var protocolStr;
		switch (protocol) {
			case phidget22.RFIDProtocol.EM4100:
				protocolStr = 'EM4100';
				break;
			case phidget22.RFIDProtocol.ISO11785_FDX_B:
				protocolStr = 'ISO11785_FDX_B';
				break;
			case phidget22.RFIDProtocol.PHIDGET_TAG:
				protocolStr = 'PHIDGET_TAG';
				break;
		}

		console.log('TagLost: ' + tag + "\tProtocol: " + protocolStr)
	}

	ch.open().then(function (ch) {
		console.log('channel open');
	}).catch(function (err) {
		console.log('failed to open the channel:' + err);
	});
}

if (require.main === module)
	main();
